Index: /cpp/gdk/extvalue.cpp
===================================================================
--- /cpp/gdk/extvalue.cpp	(revision 103)
+++ /cpp/gdk/extvalue.cpp	(revision 104)
@@ -5,10 +5,15 @@
 #include "extvalue.h"
 #include "param.h"
+#include "sstringutils.h"
 #include <math.h>
+#include <ctype.h>
+#include "collectionobj.h"
+#include "3dobject.h"
 
 SString ExtObject::toString() const
 {
 if (isEmpty()) return SString("<empty object>");
-ParamInterface *p=getParamInterface();
+Param tmp_param;
+ParamInterface *p=getParamInterface(tmp_param);
 int tostr=p->findId("toString");
 if (tostr>=0)
@@ -25,4 +30,113 @@
 	return tmp;
 	}
+}
+
+ThreadSingleton<ExtObject::Serialization> ExtObject::serialization;
+
+void ExtObject::Serialization::begin()
+{
+if (level==0)
+	refs.clear();
+level++;
+}
+
+int ExtObject::Serialization::add(const ExtObject &o)
+{
+if (o.isEmpty()) return -1;
+for(int i=0;i<refs.size();i++)
+	{
+	ExtObject& r=refs[i];
+	if (r==o) return i;
+	}
+refs.push_back(o);
+return -1;
+}
+
+void ExtObject::Serialization::replace(const ExtObject& o,const ExtObject& other)
+{
+if (o.isEmpty()) return;
+for(int i=0;i<refs.size();i++)
+	{
+	ExtObject& r=refs[i];
+	if (r==o)
+		{
+		r=other;
+		return;
+		}
+	}
+}
+
+void ExtObject::Serialization::remove(const ExtObject& o)
+{
+if (o.isEmpty()) return;
+for(int i=0;i<refs.size();i++)
+	{
+	ExtObject& r=refs[i];
+	if (o==r) refs.erase(refs.begin()+i);
+	}
+}
+
+const ExtObject* ExtObject::Serialization::get(int ref)
+{
+if (ref<0) return NULL;
+if (ref>=refs.size()) return NULL;
+return &refs[ref];
+}
+
+void ExtObject::Serialization::end()
+{
+level--;
+if (level==0)
+	refs.clear();
+}
+
+SString ExtObject::serialize_inner() const
+{
+int ref=serialization.getref().add(*this);
+if (ref>=0)
+	{
+	SString ret;
+	sprintf(ret.directAppend(20),"^%d",ref);ret.endAppend();
+	return ret;
+	}
+
+if (isEmpty()) return SString();
+VectorObject *vec=VectorObject::fromObject(*this);
+if (vec)
+	return vec->serialize();
+DictionaryObject *dic=DictionaryObject::fromObject(*this);
+if (dic)
+	return dic->serialize();
+Param tmp_param;
+ParamInterface *p=getParamInterface(tmp_param);
+int m=p->findId("toVector");
+if (m<0) 
+	m=p->findId("toDictionary");
+if (m>=0)
+	{
+	ExtObject o(p->getObject(m));
+	SString ret=SString(interfaceName())+o.serialize();
+	return ret;
+	}
+m=p->findId("toString");
+if (m>=0)
+	{
+	SString str=p->getString(m);
+	sstringQuote(str);
+	SString ret=SString(interfaceName())+"\""+str+"\"";
+	return ret;
+	}
+
+SString ret=interfaceName();
+sprintf(ret.directAppend(30),"<%p>",object?object:paraminterface);ret.endAppend();
+return ret;
+}
+
+SString ExtObject::serialize() const
+{
+serialization.getref().begin();
+SString ret=serialize_inner();
+serialization.getref().end();
+return ret;
 }
 
@@ -297,4 +411,257 @@
 }
 
+SString ExtValue::serialize() const
+{
+switch(type)
+	{
+	case TString:
+		{
+		SString q=sdata();
+		sstringQuote(q);
+		return SString("\"")+q+SString("\"");
+		}
+	case TInt:
+		{
+		SString tmp;
+		sprintf(tmp.directAppend(20),"%d",idata());
+		tmp.endAppend();
+		return tmp;
+		}
+	case TDouble:
+		{
+		SString tmp;
+		sprintf(tmp.directAppend(20),"%.15g",ddata());
+		tmp.endAppend();
+		if ((!strchr(tmp,'.'))&&(!strchr(tmp,'e'))) tmp+=".0";
+		return tmp;
+		}
+	case TObj:
+		return odata().serialize();
+	case TInvalid:
+		return SString("undefined");
+	default:
+		return SString("null");
+	}
+}
+
+//returns the first character after the parsed number or NULL if not a number
+const char* ExtValue::parseNumber(const char* in)
+{
+if (isdigit(*in)||((*in=='-')&&(isdigit(in[1]))))
+	{
+	const char* p=in;
+	if (*p=='-') p++;
+	while(isdigit(*p)) p++;
+	bool fp=false;
+	if ((*p=='.') && isdigit(p[1]))
+		{
+		p++;
+		while(isdigit(*p)) p++;
+		fp=true;
+		}
+	if (((*p=='e')||(*p=='E')) && (isdigit(p[1]) || (((p[1]=='-') || (p[1]=='+')) && isdigit(p[2]))))
+		{
+		p++;
+		if ((*p=='-')||(*p=='+')) p++;
+		while(isdigit(*p)) p++;
+		fp=true;
+		}
+
+	if (fp)
+		{
+		setDouble(atof(in));
+		return p;
+		}
+	else
+		{
+		setInt(atol(in));
+		return p;
+		}
+	}
+return NULL;
+}
+
+PtrListTempl<ParamInterface*> ExtValue::deserializable_classes;
+
+void ExtValue::initDeserializableClasses()
+{
+deserializable_classes+=&Pt3D_Ext::getStaticParam();
+deserializable_classes+=&Orient_Ext::getStaticParam();
+}
+
+ParamInterface *ExtValue::findDeserializableClass(const char* name)
+{
+FOREACH(ParamInterface*,cls,deserializable_classes)
+	if (!strcmp(cls->getName(),name))
+		return cls;
+return NULL;
+}
+
+static const char* skipWord(const char* in)
+{
+while(isalpha(*in))
+	in++;
+return in;
+}
+
+//returns the first character after the parsed portion or NULL if invalid format
+const char* ExtValue::deserialize_inner(const char* in)
+{
+const char* ret=parseNumber(in);
+if (ret)
+	return ret;
+else if (*in=='\"')
+	{
+	ret=skipQuoteString(in+1,NULL);
+	SString s(in+1,ret-(in+1));
+	sstringUnquote(s);
+	setString(s);
+	if (*ret=='\"')
+		return ret+1;
+	else
+		return NULL;
+	}
+else if (*in=='[')
+	{
+	VectorObject *vec=new VectorObject;
+	ExtObject o(&VectorObject::par,vec);
+	ExtObject::serialization.getref().add(o);
+	const char* p=in+1;
+	ExtValue tmp;
+	while(*p)
+		{
+		if (*p==']') {p++;break;}
+		ret=tmp.deserialize(p);
+		if (ret)
+			{
+			vec->data+=new ExtValue(tmp);
+			p=ret;
+			if (*p==',') p++;
+			}
+		else
+			{
+			p=NULL;
+			break;
+			}
+		}
+	setObject(o);
+	return p;
+	}
+else if (*in=='{')
+	{
+	DictionaryObject *dic=new DictionaryObject;
+	ExtObject o(&DictionaryObject::par,dic);
+	ExtObject::serialization.getref().add(o);
+	const char* p=in+1;
+	ExtValue args[2]/*={value,key}*/, dummy_ret;
+	while(*p)
+		{
+		if (*p=='}') {p++;break;}
+		ret=args[1].deserialize(p);
+		if ((!ret)||(args[1].getType()!=TString)) {p=NULL;break;}
+		p=ret;
+		if (*p!=':') {p=NULL;break;}
+		p++;
+		ret=args[0].deserialize(p);
+		if (!ret) {p=NULL;break;}
+		p=ret;
+		dic->p_set(args,&dummy_ret);
+		if (*p==',') p++;
+		}
+	setObject(o);
+	return p;
+	}
+else if (!strncmp(in,"null",4))
+	{
+	setEmpty();
+	return in+4;
+	}
+else if (!strncmp(in,"undefined",9))
+	{
+	setInvalid();
+	return in+9;
+	}
+else if (*in=='<')
+	{ //unserializable object
+	setInvalid();
+	while(*in)
+		if (*in=='>')
+			return in+1;
+		else in++;
+	return in;
+	}
+else if (*in=='^')
+	{
+	in++;
+	ExtValue ref;
+	ret=ref.parseNumber(in);
+	if (ret && (ref.getType()==TInt))
+		{
+		const ExtObject* o=ExtObject::serialization.getref().get(ref.getInt());
+		if (o)
+			{
+			setObject(*o);
+			return ret;
+			}
+		}
+	return NULL;
+	}
+else if ((ret=skipWord(in))&&(ret!=in))
+	{
+	SString clsname(in,ret-in);
+	ExtValue tmp;
+	ret=tmp.deserialize(ret);
+	ParamInterface *cls=findDeserializableClass(clsname);
+	if (cls && (tmp.getType()!=TUnknown) && (tmp.getType()!=TInvalid))
+		{
+		VectorObject *vec=VectorObject::fromObject(tmp.getObject());
+		if (vec)
+			{
+			int m=cls->findId("newFromVector");
+			if (m>=0)
+				{
+				cls->call(m,&tmp,this);
+				ExtObject::serialization.getref().replace(tmp.getObject(),getObject());
+				return ret;
+				}
+			}
+		DictionaryObject *dic=DictionaryObject::fromObject(tmp.getObject());
+		if (dic)
+			{
+			int m=cls->findId("newFromDictionary");
+			if (m>=0)
+				{
+				cls->call(m,&tmp,this);
+				ExtObject::serialization.getref().replace(tmp.getObject(),getObject());
+				return ret;
+				}
+			}
+		if (tmp.getType()==TString)
+			{
+			int m=cls->findId("newFromString");
+			if (m>=0)
+				{
+				cls->call(m,&tmp,this);
+				ExtObject::serialization.getref().replace(tmp.getObject(),getObject());
+				return ret;
+				}
+			}
+		ExtObject::serialization.getref().remove(tmp.getObject());
+		setEmpty();
+		}
+	FMprintf("ExtValue","deserialize",FMLV_WARN,"object of class \"%s\" could not be deserialized",(const char*)clsname);
+	return ret;
+	}
+return NULL;
+}
+
+const char* ExtValue::deserialize(const char* in)
+{
+ExtObject::serialization.getref().begin();
+const char* ret=deserialize_inner(in);
+ExtObject::serialization.getref().end();
+return ret;
+}
+
 ExtObject ExtValue::getObject() const
 {
@@ -307,4 +674,4 @@
 if (getType()!=TObj) return ExtValue((long)getType());
 ExtObject& o=odata();
-return ExtValue(SString(o.isEmpty()?"":o.getParamInterface()->getName()));
-}
+return ExtValue(SString(o.isEmpty()?"":o.interfaceName()));
+}
Index: /cpp/gdk/extvalue.h
===================================================================
--- /cpp/gdk/extvalue.h	(revision 103)
+++ /cpp/gdk/extvalue.h	(revision 104)
@@ -8,4 +8,6 @@
 #include "sstring.h"
 #include "param.h"
+#include "nonstd_stl.h"
+#include "threads.h"
 
 #define EXTVALUEUNION
@@ -48,16 +50,20 @@
 void* operator new(size_t s) {return malloc(sizeof(ExtObject));}
 void operator delete(void* mem) {free(mem);}
-
-ParamInterface *getParamInterface() const  {if(subtype&2){param->select(object);return param;} return paraminterface;}
-const char* interfaceName() const {if (isEmpty()) return "Empty"; return getParamInterface()->getName();}
+///@param tmp_param can be used for temporary storage, the result ParamInterface* is only valid for as long as tmp_param is valid
+ParamInterface *getParamInterface(Param &tmp_param) const  {if(subtype&2){tmp_param.setParamTab(param->getParamTab());tmp_param.select(object);return &tmp_param;} return paraminterface;}
+const char* interfaceName() const {if (isEmpty()) return "Empty"; return (subtype&2)?param->getName():paraminterface->getName();}
+bool matchesInterfaceName(ParamInterface* pi) const {return !strcmp(interfaceName(),pi->getName());}
 void* getTarget() const {return (subtype&1)?dbobject:object;}
 void* getTarget(const char* classname) const {return strcmp(interfaceName(),classname)?0:getTarget();}
+void setEmpty() {decref();subtype=0;param=NULL;object=NULL;}
 int isEmpty() const {return !param;}
 ExtObject(const ExtObject& src)      {src.incref();copyFrom(src);}
 void operator=(const ExtObject& src) {src.incref();decref();copyFrom(src);}
 
-int operator==(const ExtObject& src) {if (object!=src.object) return 0; return (object==0)?(param==src.param):1;}
+int operator==(const ExtObject& src) const {if (object!=src.object) return 0; return (object==0)?(!strcmp(param->getName(),src.param->getName())):1;}
 
 SString toString() const;
+SString serialize_inner() const;
+SString serialize() const;
 
 ExtObject(Param *p,void *o):subtype(2),object(o),param(p){}
@@ -67,6 +73,20 @@
 
 ~ExtObject(){decref();}
+
+class Serialization
+{
+std::vector<ExtObject> refs;
+int level;
+  public:
+void begin();
+void end();
+int add(const ExtObject& o);
+void replace(const ExtObject& o,const ExtObject& other);
+void remove(const ExtObject& o);
+const ExtObject* get(int ref);
 };
 
+static ThreadSingleton<Serialization> serialization;
+};
 
 class ExtValue
@@ -124,5 +144,12 @@
 double getDouble() const;
 SString getString() const;
+SString serialize() const;
 ExtObject getObject() const;
+const char* parseNumber(const char* in);
+const char* deserialize(const char* in);//< @return first character after the succesfully parsed string or NULL if failed
+const char* deserialize_inner(const char* in);
+static PtrListTempl<ParamInterface*> deserializable_classes;
+static ParamInterface *findDeserializableClass(const char* name);
+static void initDeserializableClasses();
 
 ExtValue getExtType();
Index: /cpp/gdk/framsg.cpp
===================================================================
--- /cpp/gdk/framsg.cpp	(revision 103)
+++ /cpp/gdk/framsg.cpp	(revision 104)
@@ -11,12 +11,10 @@
 #endif
 
-static const char *warn="[warn] ";
-static const char *err="[ERROR] ";
+char* MSG_LEVEL[]={"DEBUG","INFO","WARN","ERROR","CRITICAL"};
 
 /* TODO integracja z error managerem 
 void FramMessage(const char *o,const char *m,const char *bl,int w)
 {
-  const char *lvl="";
-  if (w==1) lvl=warn; else if (w>1) lvl=err;
+  const char *lvl=MSG_LEVEL[w+1];
 #ifdef SHP
   //jesli chcemy zeby nawet w trybie release wysylal komunikaty:
Index: /cpp/gdk/framsg.h
===================================================================
--- /cpp/gdk/framsg.h	(revision 103)
+++ /cpp/gdk/framsg.h	(revision 104)
@@ -4,7 +4,9 @@
 #include <stdarg.h>
 
+extern char* MSG_LEVEL[];
+
 void FMprintf(const char *o,const char *m,int w,const char *bl, ...);
 void FMprintf(const char *o,const char *m,int w,const char *bl,va_list va);
-void FMprintf(const char *bl,...); //dla leniwych - zastepuje printf
+void FMprintf(const char *bl,...); //for lazy people - instead of printf
 void FramMessage(const char *o,const char *m,const char *bl,int w);
 
@@ -17,10 +19,10 @@
 /*
 w: weight (importance) of a message
--1:debugging information, not needed for final users
-0: information
-1: warning or corrected error
-2: uncorrected error. can cause malfunction
-3: serious error, causes side effects. user should save what can be
-   saved and restart the application
+
+-1: debugging information, not needed for final users
+ 0: information
+ 1: warning or corrected error
+ 2: uncorrected error. can cause malfunction
+ 3: serious error, causes side effects. user should save what can be saved and restart the application
 */
 
Index: /cpp/gdk/gdktest.cpp
===================================================================
--- /cpp/gdk/gdktest.cpp	(revision 103)
+++ /cpp/gdk/gdktest.cpp	(revision 104)
@@ -28,5 +28,5 @@
        "    ########################################\n",title);
 }
-void printProperties(ParamInterface &pi)
+void printProperties(Param &pi)
 {
 printf(" #        id                      type  name        group (%d properties)\n",pi.getPropCount());
@@ -39,5 +39,7 @@
 }
 
-void changeOneProperty(ParamInterface &pi)
+#define PRINT_PROPERTIES(p) {Param tmp_param(p); printProperties(tmp_param);}
+
+void changeOneProperty(Param &pi)
 {
 if (pi.getPropCount()<=0) return;
@@ -54,4 +56,6 @@
 }
 
+#define CHANGE_ONE_PROPERTY(p) {Param tmp_param(p); changeOneProperty(tmp_param);}
+
 void moreAboutPart(Part* p)
 {
@@ -61,5 +65,5 @@
        "and should be handled with care, because they influence other elements of the model.\n\n"
        " [this data is provided by Part::properties() ]\n");
-printProperties(p->properties());
+PRINT_PROPERTIES(p->properties());
 printf("\nHowever, there is a subset of properties which may be modified more freely.\n"
        "Properties on this list are related only to this part and can be changed\n"
@@ -67,5 +71,5 @@
        "will be silently repaired.\n"
        "\n [this data is provided by Part::extraProperties() ]\n");
-printProperties(p->extraProperties());
+PRINT_PROPERTIES(p->extraProperties());
 printf("\nThis set of properties can vary from release to release,\n"
        "but can be safely accessed by using extraProperties() call.\n"
@@ -74,5 +78,5 @@
        "Now we will try to change some of properties:\n\n");
 p->getModel().open();
-changeOneProperty(p->extraProperties());
+CHANGE_ONE_PROPERTY(p->extraProperties());
 p->getModel().close();
 printf("\nLet's see f0... (check out part #%d !)\n\n%s\n", p->refno, (const char*)p->getModel().getF0Geno().getGene());
@@ -127,5 +131,5 @@
 {
 printf("Similarly as with Part, the full list of properties comes first:\n\n");
-printProperties(j->properties());
+CHANGE_ONE_PROPERTY(j->properties());
 printf("\nActually, there are two kinds of Joints: delta and absolute.\n"
        "For this object, Joint::isDelta() returns %d, so this is the %s Joint.\n",
@@ -147,8 +151,8 @@
        "The other properties are available from Joint::extraProperties()\n"
        "and at the moment are defined as follows:\n\n");
-printProperties(j->extraProperties());
+PRINT_PROPERTIES(j->extraProperties());
 printf("\nThey can be changed just like Part's extra properties:\n");
 j->getModel().open();
-changeOneProperty(j->extraProperties());
+CHANGE_ONE_PROPERTY(j->extraProperties());
 j->getModel().close();
 printf("And after that we have this genotype:\n\n%s\n", (const char*)j->getModel().getF0Geno().getGene());
@@ -161,10 +165,10 @@
 printf("Basic features of Neuro object are similar to those of Part and Joint.\n"
        "We can request a property list:\n\n");
-printProperties(n->properties());
+PRINT_PROPERTIES(n->properties());
 printf("\n...and extra properties (which are designed to be always valid and easy to change):\n\n");
-printProperties(n->extraProperties());
+PRINT_PROPERTIES(n->extraProperties());
 printf("\nAs usual, we will change something:\n");
 n->getModel().open();
-changeOneProperty(n->extraProperties());
+CHANGE_ONE_PROPERTY(n->extraProperties());
 n->getModel().close();
 printf("Each neuron can have any number of inputs = weighted connections\n with other neurons.\n"
Index: /cpp/gdk/genoconv.cpp
===================================================================
--- /cpp/gdk/genoconv.cpp	(revision 103)
+++ /cpp/gdk/genoconv.cpp	(revision 104)
@@ -32,7 +32,6 @@
 {
 if (i>=gcm->converters.size()) return 0;
-static char t[20];
-sprintf(t,"genkonw%d",i);
-return t;
+sprintf(tmp_id,"genkonw%d",i);
+return tmp_id;
 }
 
@@ -174,5 +173,5 @@
 {
 if (in.getFormat()==format) return in;
-static char path[10];
+char path[10];
 int dep;
 char *ret;
Index: /cpp/gdk/genoconv.h
===================================================================
--- /cpp/gdk/genoconv.h	(revision 103)
+++ /cpp/gdk/genoconv.h	(revision 104)
@@ -21,4 +21,5 @@
 GenoConvManager *gcm;
 std::vector<std::string> gcnames;
+char tmp_id[20];
 void freetab();
 public:
Index: /cpp/gdk/genotypeloader.cpp
===================================================================
--- /cpp/gdk/genotypeloader.cpp	(revision 103)
+++ /cpp/gdk/genotypeloader.cpp	(revision 104)
@@ -22,5 +22,5 @@
 void MiniGenotypeLoader::init()
 {
-addClass(&genotype_param);
+addObject(&genotype_param);
 breakOn(MultiParamLoader::OnError + MultiParamLoader::AfterObject);
 }
@@ -29,5 +29,5 @@
 {
 genotype_object.clear();
-if ((go()==AfterObject)&&(getClass()==&genotype_param))
+if ((go()==AfterObject)&&(getObject().matchesInterfaceName(&genotype_param)))
 	return &genotype_object;
 else
Index: /cpp/gdk/hashtable.cpp
===================================================================
--- /cpp/gdk/hashtable.cpp	(revision 104)
+++ /cpp/gdk/hashtable.cpp	(revision 104)
@@ -0,0 +1,195 @@
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
+#include "hashtable.h"
+
+int HashTable::hash(const char *s)
+{
+int h=0;
+char c;
+while(c=*(s++))
+    h=31*h+c;
+return h&0x7fffffff;
+}
+
+void HashTable::init(int initsize,float lo)
+{
+size=initsize;
+load=lo;
+threshold=(int)(load*size);
+tab=(HashEntry**)calloc(size,sizeof(HashEntry*));
+count=0;
+sync=0;
+}
+
+void HashTable::rehash(int newsize)
+{
+if (newsize==size) return;
+HashEntry **newtab=(HashEntry**)calloc(newsize,sizeof(HashEntry*));
+HashEntry **te=tab,*e,*ne;
+int i;
+for (int s=size;s>0;s--,te++)
+    for (e=*te;e;)
+	{
+	    ne=e; e=e->next;
+	    i=ne->hash%newsize;
+	    ne->next=newtab[i];
+	    newtab[i]=ne;
+	}
+free(tab);
+tab=newtab;
+size=newsize;
+threshold=int(load*size);
+sync++;
+}
+
+void HashTable::clear()
+{
+HashEntry *e,**te,*next;
+int n;
+for (n=size,te=tab;n>0;n--,te++)
+	for (e=*te;e;e=next)
+		{
+		next=e->next;
+		delete e;
+		}
+if (tab) free(tab);
+tab=0; size=0;
+sync++;
+}
+
+HashTable::~HashTable()
+{
+clear();
+}
+
+void* HashTable::put(const SString& key,void *value)
+{
+int h=hash(key);
+int i=h%size;
+for (HashEntry *e=tab[i];e;e=e->next)
+    {
+    if (e->key==key)
+	{
+	void *v=e->value;
+	e->value=value;
+	return v;
+	}
+    }
+if (count>=threshold) { rehash(2*size+1); i=h%size; }
+HashEntry *e=new HashEntry(h,key,value);
+e->next=tab[i];
+tab[i]=e;
+count++;
+sync++;
+return 0;
+}
+
+void* HashTable::remove(const SString& key)
+{
+int i=hash(key)%size;
+HashEntry **ptr=tab+i,*e;
+for (;e=*ptr;ptr=&e->next)
+    {
+    if (e->key==key)
+	{
+	*ptr=e->next;
+	void *v=e->value;
+	delete e;
+	count--;
+	sync++;
+	return v;
+	}
+    }
+return 0;
+}
+
+void* HashTable::remove(HashEntryIterator& it)
+{
+if (!it.entry) return 0;
+HashEntry **ptr=tab+it.hashindex,*e;
+for (;e=*ptr;ptr=&e->next)
+    {
+    if (e == it.entry)
+	{
+	it++;
+	*ptr=e->next;
+	void *v=e->value;
+	delete e;
+	count--;
+	sync++;
+	it.sync++;
+	return v;
+	}
+    }
+   return NULL; 
+}
+
+void* HashTable::get(const SString& key,int *reallygot)
+{
+int i=hash(key)%size;
+for (HashEntry *e=tab[i];e;e=e->next)
+	if (e->key==key) {if (reallygot) *reallygot=1; return e->value;}
+return 0;
+}
+
+/////////
+
+void HashEntryIterator::findNext()
+{
+while (hashindex < (ht->size-1))
+	{
+	hashindex++;
+	if (entry=ht->tab[hashindex]) return;
+	}
+}
+
+
+void HashEntryIterator::operator++()
+{
+if (entry) entry=entry->next;
+if (!entry) findNext();
+}
+
+//////////////////////////
+
+void HashTable::debugprint()
+{
+printf("HashTable: %d/%d (max %d)\n",count,size,threshold);
+HashEntry *e,**te;
+int n;
+for (n=0,te=tab;n<size;n++,te++)
+	if (e=*te)
+	{
+	printf(" %d:",n);
+	for (;e;e=e->next)
+		printf(" (%x)%s=%p",e->hash,(const char*)e->key,e->value);
+	printf("\n");
+	}
+}
+
+/**
+stats[0]=buckets used
+stats[1]=min keys in bucket
+stats[2]=avg keys in bucket
+stats[3]=max keys in bucket
+ */
+void HashTable::getstats(float *stats)
+{
+HashEntry *e,**te;
+int used=0, ma=0, mi=count;
+int c,n;
+for (n=size,te=tab;n>0;n--,te++)
+	{
+	c=0;
+	for (e=*te;e;e=e->next) c++;
+	if (c>ma) ma=c;
+	if ((c<mi)&&(c>0)) mi=c;
+	if (c>0) used++;
+	}
+stats[0]=used;
+stats[1]=(mi==count)?0:mi;
+stats[2]=(float)count/(float)used;
+stats[3]=ma;
+}
Index: /cpp/gdk/hashtable.h
===================================================================
--- /cpp/gdk/hashtable.h	(revision 104)
+++ /cpp/gdk/hashtable.h	(revision 104)
@@ -0,0 +1,84 @@
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
+#ifndef _HASHTABLE_H_
+#define _HASHTABLE_H_
+
+#include "sstring.h"
+
+class HashEntry
+{
+public:
+int hash;
+SString key;
+void *value;
+HashEntry *next;
+
+HashEntry(int h,const SString& k,void *v):hash(h),key(k),value(v),next(0){}
+};
+
+class HashEntryIterator;
+
+class HashTable
+{
+friend class HashEntryIterator;
+HashEntry **tab;
+int size;
+int count;
+int threshold;
+float load;
+long sync;
+
+int hash(const char *s);
+void rehash(int newsize);
+public:
+
+HashTable(int initsize,float lo) {init(initsize,lo);}
+HashTable(int initsize) {init(initsize,0.75);}
+HashTable() {init();}
+~HashTable();
+
+/** always use init() after clear() ! */
+void clear();
+void init(int initsize=11,float lo=0.75);
+
+int getSize() {return count;}
+void* put(const SString& key,void *value);
+void* get(const SString& key, int *reallygot=0);
+void* remove(const SString& key);
+/** can be used inside iteration loop:
+    for(HashEntryIterator it(hashtable);it;) hashtable.remove(it);
+    \note iterator is "iterated" to the next entry when the current one is removed (no "it++"!)
+ */
+void* remove(HashEntryIterator& it);
+
+void debugprint();
+void getstats(float *);
+};
+
+/** for(HashEntryIterator it(hashtable);it;it++)
+      {
+      ... it->value
+      ... it->key
+      }
+ */
+class HashEntryIterator
+{
+void findNext();
+  public:
+const HashTable *ht;
+int hashindex;
+HashEntry *entry;
+int sync;
+  HashEntryIterator(const HashTable&t):ht(&t),hashindex(0),entry(t.tab[0]),sync(ht->sync)
+	{if (!entry) findNext();}
+  HashEntryIterator() {}
+void operator++();
+void operator++(int) {operator++();}
+HashEntry* operator->() {return entry;}
+bool isValid() {return (entry&&(sync==ht->sync))?1:0;}
+};
+
+
+#endif
Index: /cpp/gdk/list.h
===================================================================
--- /cpp/gdk/list.h	(revision 103)
+++ /cpp/gdk/list.h	(revision 104)
@@ -57,5 +57,5 @@
 SListTempl(const SListTempl<T>& src):have(0),used(0),mem(0),pos(0)
 	{(*this)=src;}
-SListTempl():have(0),used(0),mem(0),pos(0)
+SListTempl():have(0),used(0),pos(0),mem(0)
 	{}
 ~SListTempl()
Index: /cpp/gdk/model.cpp
===================================================================
--- /cpp/gdk/model.cpp	(revision 103)
+++ /cpp/gdk/model.cpp	(revision 104)
@@ -382,9 +382,9 @@
 SString gen;
 
-static Param modelparam(f0_model_paramtab);
-static Param partparam(f0_part_paramtab);
-static Param jointparam(f0_joint_paramtab);
-static Param neuroparam(f0_neuro_paramtab);
-static Param connparam(f0_neuroconn_paramtab);
+Param modelparam(f0_model_paramtab);
+Param partparam(f0_part_paramtab);
+Param jointparam(f0_joint_paramtab);
+Param neuroparam(f0_neuro_paramtab);
+Param connparam(f0_neuroconn_paramtab);
 
 static Part defaultpart;
@@ -563,5 +563,5 @@
 if (!strncmp(t,"p:",2))
 	{
-	static Param partparam(f0_part_paramtab);
+	Param partparam(f0_part_paramtab);
 	Part *p=new Part();
 	partparam.select(p);
@@ -576,5 +576,5 @@
 if (!strncmp(t,"m:",2))
 	{
-	static Param modelparam(f0_model_paramtab);
+	Param modelparam(f0_model_paramtab);
 	modelparam.select(this);
 	pos+=2;
@@ -584,5 +584,5 @@
 else if (!strncmp(t,"j:",2))
 	{
-	static Param jointparam(f0_joint_paramtab);
+	Param jointparam(f0_joint_paramtab);
 	Joint *j=new Joint();
 	jointparam.select(j);
@@ -610,5 +610,5 @@
 else if (!strncmp(t,"n:",2)) // neuro (or the old neuro object as the special case)
 	{
-	static Param neuroparam(f0_neuro_paramtab);
+	Param neuroparam(f0_neuro_paramtab);
 	Neuro *nu=new Neuro();
 	neuroparam.select(nu);
@@ -674,5 +674,5 @@
 else if (!strncmp(t,"c:",2)) // add input
 	{
-	static Param ncparam(f0_neuroconn_paramtab);
+	Param ncparam(f0_neuroconn_paramtab);
 	NeuroConn c;
 	ncparam.select(&c);
@@ -696,5 +696,5 @@
 	{
 	// we always use old layout for "ni:"
-	static Param neuroitemparam(f0_neuroitem_paramtab);
+	Param neuroitemparam(f0_neuroitem_paramtab);
 	Neuro *nu=new Neuro();
 	neuroitemparam.select(nu);
@@ -1085,11 +1085,10 @@
 }
 
-const Geno& Model::getF0Geno()
-{
-static Geno invalidgeno("",'0',"","invalid");
+const Geno Model::getF0Geno()
+{
 if (buildstatus==building)
 	FMprintf("Model","getGeno",FMLV_WARN,"model was not completed - missing close()");
 if (buildstatus!=valid)
-	return invalidgeno;
+	return Geno("",'0',"","invalid");
 if (!f0genoknown)
 	{
Index: /cpp/gdk/model.h
===================================================================
--- /cpp/gdk/model.h	(revision 103)
+++ /cpp/gdk/model.h	(revision 104)
@@ -212,5 +212,5 @@
     don't use between open()-close()
 */
-const Geno &getF0Geno();
+const Geno getF0Geno();
 
 /// make f0 genotype from current construction (low level version of getF0Geno)
Index: /cpp/gdk/modelparts.cpp
===================================================================
--- /cpp/gdk/modelparts.cpp	(revision 103)
+++ /cpp/gdk/modelparts.cpp	(revision 104)
@@ -97,13 +97,12 @@
 		       int _prefinputs,int _prefoutput,int _preflocation,
 		       int *_vectordata,bool own_vd,int vhints)
-	:longname(_props->id),
-	 name(_props->name),
-	 description(_description),
+	:ownedvectordata(own_vd),
+	 name(_props->name),longname(_props->id),description(_description),
 	 props(_props),
 	 prefinputs(_prefinputs),
 	 prefoutput(_prefoutput),
 	 preflocation(_preflocation),
-	 vectordata(_vectordata),ownedvectordata(own_vd),
-	 visualhints(vhints),impl(0),active(1),genactive(0)
+	 vectordata(_vectordata),
+	 visualhints(vhints),impl_count(0),/*impl(0),*/active(1),genactive(0)
 {}
 
@@ -114,8 +113,10 @@
 
 NeuroClass::NeuroClass()
-	:name("Invalid"),props(empty_paramtab),
+	:ownedvectordata(0),
+	 name("Invalid"),
+	 props(empty_paramtab),
 	 prefinputs(0), prefoutput(0),
-	 preflocation(0), vectordata(0), ownedvectordata(0),
-	 impl(0), active(1), genactive(0)
+	 preflocation(0), vectordata(0), 
+	 visualhints(0),impl_count(0), /*impl(0),*/ active(1), genactive(0)
 {}
 
@@ -176,5 +177,5 @@
 
 Neuro::Neuro(double _state,double _inertia,double _force,double _sigmo)
-	:state(_state),PartBase(getDefaultStyle())
+	:PartBase(getDefaultStyle()),state(_state)
 #ifdef MODEL_V1_COMPATIBLE
 ,inertia(_inertia),force(_force),sigmo(_sigmo)
@@ -187,4 +188,5 @@
 myclass=0;
 knownclass=1;
+part_refno=-1; joint_refno=-1;
 }
 
@@ -204,4 +206,5 @@
 #endif
 flags=0;
+part_refno=-1; joint_refno=-1;
 }
 
@@ -614,8 +617,8 @@
 ///////////////////////////////////////
 
-const SString& Part::getDefaultStyle()
-{static SString s("part"); return s;}
-const SString& Joint::getDefaultStyle()
-{static SString s("joint"); return s;}
+SString Part::getDefaultStyle()
+{return SString("part");}
+SString Joint::getDefaultStyle()
+{return SString("joint");}
 /*
 const SString& Neuro::getDefaultStyle()
@@ -624,6 +627,6 @@
 {static SString s("neuroitem"); return s;}
 */
-const SString& Neuro::getDefaultStyle()
-{static SString s("neuro"); return s;}
+SString Neuro::getDefaultStyle()
+{return SString("neuro");}
 
 Part::Part():PartBase(getDefaultStyle())
@@ -776,46 +779,32 @@
 };
 
-static Param staticparam;
-
-ParamInterface &Part::extraProperties()
-{
-staticparam.setParamTab(f0_part_xtra_paramtab);
-staticparam.select(this);
-return staticparam;
-}
-
-ParamInterface &Joint::extraProperties()
-{
-staticparam.setParamTab(f0_joint_xtra_paramtab);
-staticparam.select(this);
-return staticparam;
-}
-
-ParamInterface &Neuro::extraProperties()
-{
-staticparam.setParamTab(f0_neuro_xtra_paramtab);
-staticparam.select(this);
-return staticparam;
-}
-
-ParamInterface &Part::properties()
-{
-staticparam.setParamTab(f0_part_paramtab);
-staticparam.select(this);
-return staticparam;
-}
-
-ParamInterface &Joint::properties()
-{
-staticparam.setParamTab(usedelta?f0_joint_paramtab:f0_nodeltajoint_paramtab);
-staticparam.select(this);
-return staticparam;
-}
-
-ParamInterface &Neuro::properties()
-{
-staticparam.setParamTab(f0_neuro_paramtab);
-staticparam.select(this);
-return staticparam;
+Param Part::extraProperties()
+{
+return Param(f0_part_xtra_paramtab,this);
+}
+
+Param Joint::extraProperties()
+{
+return Param(f0_joint_xtra_paramtab,this);
+}
+
+Param Neuro::extraProperties()
+{
+return Param(f0_neuro_xtra_paramtab,this);
+}
+
+Param Part::properties()
+{
+return Param(f0_part_paramtab,this);
+}
+
+Param Joint::properties()
+{
+return Param(usedelta?f0_joint_paramtab:f0_nodeltajoint_paramtab,this);
+}
+
+Param Neuro::properties()
+{
+return Param(f0_neuro_paramtab,this);
 }
 
